"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_debounce_1 = __importDefault(require("lodash.debounce"));
var lodash_throttle_1 = __importDefault(require("lodash.throttle"));
var React = __importStar(require("react"));
var setRefreshRate = function (cb, refreshOptions) {
    var _a = refreshOptions || {}, mode = _a.mode, _b = _a.rate, rate = _b === void 0 ? 250 : _b, leading = _a.leading, trailing = _a.trailing;
    switch (mode) {
        case "debounce": {
            var lodashOptions = {
                leading: leading != null ? leading : false,
                trailing: trailing != null ? trailing : true
            };
            // eslint-disable-next-line @typescript-eslint/no-unsafe-call
            return (0, lodash_debounce_1.default)(cb, rate, lodashOptions);
        }
        case "throttle": {
            var lodashOptions = {
                leading: leading != null ? leading : true,
                trailing: trailing != null ? trailing : true
            };
            // eslint-disable-next-line @typescript-eslint/no-unsafe-call
            return (0, lodash_throttle_1.default)(cb, rate, lodashOptions);
        }
        default:
            return cb;
    }
};
var useResizeSensor = function (refreshOptions) {
    var _a = React.useState({ width: 0, height: 0 }), size = _a[0], setSize = _a[1];
    var handleOnResize = React.useCallback(function (entries) {
        entries.forEach(function (entry) {
            var _a = entry.contentRect, width = _a.width, height = _a.height;
            setSize(function (prevSize) {
                if (prevSize.width === width && prevSize.height === height)
                    return prevSize;
                return { width: width, height: height };
            });
        });
    }, []);
    var resizeCallback = React.useMemo(function () { return setRefreshRate(handleOnResize, refreshOptions); }, [handleOnResize, refreshOptions]);
    var registerCleanupRef = React.useRef(null);
    var registerNode = React.useCallback(function (node) {
        if (registerCleanupRef.current !== null) {
            registerCleanupRef.current();
            registerCleanupRef.current = null;
        }
        if (node != null) {
            var observer_1 = new ResizeObserver(resizeCallback);
            observer_1.observe(node);
            registerCleanupRef.current = function () {
                observer_1.disconnect();
                if (resizeCallback.cancel)
                    resizeCallback.cancel();
            };
        }
    }, [resizeCallback]);
    return { width: size.width, height: size.height, registerNode: registerNode };
};
exports.default = useResizeSensor;
